// Show_AC97_Registers.cpp
//
// 24feb04 ak
// - created based on AC97 code AudioLoop.exe (ADS #720020-11641,
//   forum topic 1245) and interal test code (AccessAC97.cpp wh)
//
//

#include "stdafx.h"
#include "wavedev.h"

#define WPDM_PRIVATE_WRITE_AC97		0
#define WPDM_PRIVATE_READ_AC97		1

//-------------------------------------------------------------------
//-------------------------------------------------------------------
DWORD ReadAC97Register (HANDLE hWAV, DWORD offset)
{
	MMDRV_MESSAGE_PARAMS Params;
	ULONG dwData = 0;
	BOOL  fRet;

	// Specify that we want to read values
	Params.uMsg = WPDM_PRIVATE_READ_AC97;

	// Choose the register we want to read.
	Params.dwParam1 = offset;

	// Point to location for return data
	Params.dwParam2 = (ULONG)&dwData;

	RETAILMSG(TRUE, (_T("   +0x%02X "), offset));

	fRet = DeviceIoControl(hWAV, IOCTL_WAV_MESSAGE, (LPVOID)&Params, 
						   sizeof(MMDRV_MESSAGE_PARAMS), NULL, 0, NULL, 0);
	if (!fRet)
		RETAILMSG(1, (TEXT("! Unable Read AC97 register (error # %d)\r\n"),GetLastError()));
	else 
		RETAILMSG(1, (TEXT("= 0x%04x\r\n"), dwData));

	return dwData;
}

//-------------------------------------------------------------------
//-------------------------------------------------------------------
int WINAPI WinMain(	HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPTSTR    lpCmdLine,
					int       nCmdShow)
{
	HANDLE hWAV;

	RETAILMSG(TRUE, (L"\r\n* Show_AC97_Registers: Displays current values of AC97 registers\r\n"));
 	RETAILMSG(TRUE, (L"(app built %s %s)\r\n",TEXT(__DATE__),TEXT(__TIME__)));


	// Open AC97 wave device
	hWAV = CreateFile(TEXT("WAV1:"), GENERIC_READ|GENERIC_WRITE, 0,
		 NULL, OPEN_EXISTING, 0, NULL);

	if (hWAV == INVALID_HANDLE_VALUE)
	{
	  RETAILMSG(TRUE, (_T("Can't open WAV1: audio device.  Application aborted.\r\n")));
	  return -1;
	}

	// Read codec registers
	RETAILMSG(TRUE, (L"Reset register:\r\n"));
	ReadAC97Register (hWAV, 0x00);

	RETAILMSG(TRUE, (L"Volume control registers:\r\n"));
	ReadAC97Register (hWAV, 0x02);
	ReadAC97Register (hWAV, 0x04);
	ReadAC97Register (hWAV, 0x06);

	ReadAC97Register (hWAV, 0x0A);
	ReadAC97Register (hWAV, 0x0C);
	ReadAC97Register (hWAV, 0x0E);

	ReadAC97Register (hWAV, 0x10);
	ReadAC97Register (hWAV, 0x12);
	ReadAC97Register (hWAV, 0x14);
	ReadAC97Register (hWAV, 0x16);
	ReadAC97Register (hWAV, 0x18);

	RETAILMSG(TRUE, (L"Record select, gain:\r\n"));
	ReadAC97Register (hWAV, 0x1A);
	ReadAC97Register (hWAV, 0x1C);

	RETAILMSG(TRUE, (L"More registers:\r\n"));
	ReadAC97Register (hWAV, 0x20);

	ReadAC97Register (hWAV, 0x26);
	ReadAC97Register (hWAV, 0x28);
	ReadAC97Register (hWAV, 0x2A);
	ReadAC97Register (hWAV, 0x2C);

	ReadAC97Register (hWAV, 0x32);

	ReadAC97Register (hWAV, 0x3A);
	ReadAC97Register (hWAV, 0x3C);
	ReadAC97Register (hWAV, 0x3E);

	ReadAC97Register (hWAV, 0x4C);
	ReadAC97Register (hWAV, 0x4E);

	ReadAC97Register (hWAV, 0x50);
	ReadAC97Register (hWAV, 0x52);
	ReadAC97Register (hWAV, 0x54);

	RETAILMSG(TRUE, (L"Cirrus Logic defined registers:\r\n"));
	ReadAC97Register (hWAV, 0x5E);
	ReadAC97Register (hWAV, 0x60);
	ReadAC97Register (hWAV, 0x6A);
	ReadAC97Register (hWAV, 0x70);
	ReadAC97Register (hWAV, 0x72);
	ReadAC97Register (hWAV, 0x7A);
	ReadAC97Register (hWAV, 0x7C);
	ReadAC97Register (hWAV, 0x7E);

	// Shut down
    CloseHandle(hWAV);
	RETAILMSG(TRUE, (L"* Show_AC97_Registers: Complete\r\n"));

	return 0;
}

